#include once "fbgfx.bi"
#include once "inc/xmlparse.bi"
#include once "inc/mdLanguage.bi"
dim as string language = "deutsch"
loadCustomLanguage(l, language, exepath & "/lang/", "", "")

#include once "inc/mages.bi"

#include once "sGUI/sGUI.bas"
#include once "sGUI/SimpleGadget.bas"
#include once "sGUI/StringGadget.bas"
#include once "sGUI/ListBox.bas"
#include once "sGUI/Label.bas"
#include once "sGUI/ComboBox.bas"

using sGUI

'Kartensets einlesen
dim as string filename = dir(exepath & "/cards/*.xml"), set()
dim as integer setnumber = 0
do while len(filename)
  redim preserve set(ubound(set)+1)
  set(ubound(set)) = filename
  filename = dir
loop

type TEffPair
  as string effect, target
  declare constructor
  declare constructor(eff as string, tar as string)
end type
constructor TEffPair
end constructor
constructor TEffPair(eff as string, tar as string)
  this.effect = eff
  this.target = tar
end constructor

declare sub gadgetOnSleep(onSleep as integer, gad as Gadget ptr)
declare function getCondName(condition as TCond) as string
declare function getEffectName(condition as TCond, power as integer) as TEffPair
declare sub setCard(c as integer, condList() as string, effList() as string)
declare sub updateAll(player() as TPlayer)
declare sub updateCard(c as integer, player() as TPlayer)
declare sub writeCards(filename as string, language as string)

screenres 900, 650, 32
initGFX

dim as string condList(0 to ...) = { "<Wert>", "eig. Stein", "eig. Kristall", "eig. Kreatur", "eig. Stein-Prod", _
              "eig. Kristall-Prod", "eig. Kreatur-Prod","eig. Mauer", "eig. Turm", "geg. Stein", "geg. Kristall", _
              "geg. Kreatur", "geg. Stein-Prod", "geg. Kristall-Prod", "geg. Kreatur-Prod","geg. Mauer", _
              "geg. Turm", "Diff Stein", "Diff Kristall", "Diff Kreatur", "Diff Stein-Prod", "Diff Kristall-Prod", _
              "Diff Kreatur-Prod","Diff Mauer", "Diff Turm", "Diff eig. Bauwerke", "Diff geg. Bauwerke" }
dim as string effList(0 to ...) = { "<leer>", "eig. Stein", "eig. Kristall", "eig. Kreatur", "eig. Stein-Prod", _
              "eig. Kristall-Prod", "eig. Kreatur-Prod", "geg. Stein", "geg. Kristall", "geg. Kreatur", _
              "geg. Stein-Prod", "geg. Kristall-Prod", "geg. Kreatur-Prod", "beide Stein", "beide Kristall", _
              "beide Kreatur", "beide Stein-Prod", "beide Kristall-Prod", "beide Kreatur-Prod", "stehle Stein", _
              "stehle Kristall", "stehle Kreatur", "stehle Stein-Prod", "stehle Kristall-Prod", "stehle Kreatur-Prod", _
              "eigene Mauer", "gegn. Mauer", "beide Mauern", "eigener Turm", "gegn. Turm", "beide Tuerme", _
              "eig. Schaden", "geg. Schaden", "beide Schaden" }
dim as EventHandle ptr event = new EventHandle
dim shared as Gadget ptr cardName, costValue, costType, descCommon, againLabel, againCombo
dim shared as Gadget ptr cond1Combo(3), compCombo(3), cond2Combo(3), compValue(3), compBox(3)
dim shared as Gadget ptr eff1Combo(3), power1(3), relat1Combo(3), desc1(3), descLabel(3)
dim shared as Gadget ptr eff2Combo(3), power2(3), relat2Combo(3), desc2(3)
dim shared as Gadget ptr ifLabel(3), thenLabel(3), elseLabel(3), relat1Label(3), relat2Label(3)
dim shared as Gadget ptr descName, descCost, descComm, descOwn, descOpp
dim shared as Gadget ptr descStone, descCryst, descCreat, descStoneP, descCrystP, descCreatP, descWall, descTower
dim shared as Gadget ptr ownStone, ownCryst, ownCreat, ownStoneP, ownCrystP, ownCreatP, ownWall, ownTower
dim shared as Gadget ptr oppStone, oppCryst, oppCreat, oppStoneP, oppCrystP, oppCreatP, oppWall, oppTower
dim as TPlayer player(1 to 2)

descName   = addLabel(event,  10, 302, "Kartenname:")
descCost   = addLabel(event, 380, 302, "Kosten:")
descComm   = addLabel(event,  10, 332, "allgemeine Beschreibung:")
descOwn    = addLabel(event, 750, 145, "selbst")
descOpp    = addLabel(event, 820, 145, "Gegner")
descStone  = addLabel(event, 620, 162, "Stein:")
descCryst  = addLabel(event, 620, 177, "Kristall:")
descCreat  = addLabel(event, 620, 192, "Kreatur:")
descStoneP = addLabel(event, 620, 207, "Stein-Prod:")
descCrystP = addLabel(event, 620, 222, "Kristall-Prod:")
descCreatP = addLabel(event, 620, 237, "Kreatur-Prod:")
descWall   = addLabel(event, 620, 252, "Mauer:")
descTower  = addLabel(event, 620, 267, "Turm:")
ownStone   = addStringGadget(event, 750, 160, 5,, 3)
oppStone   = addStringGadget(event, 820, 160, 5,, 3)
ownCryst   = addStringGadget(event, 750, 175, 5,, 3)
oppCryst   = addStringGadget(event, 820, 175, 5,, 3)
ownCreat   = addStringGadget(event, 750, 190, 5,, 3)
oppCreat   = addStringGadget(event, 820, 190, 5,, 3)
ownStoneP  = addStringGadget(event, 750, 205, 5,, 3)
oppStoneP  = addStringGadget(event, 820, 205, 5,, 3)
ownCrystP  = addStringGadget(event, 750, 220, 5,, 3)
oppCrystP  = addStringGadget(event, 820, 220, 5,, 3)
ownCreatP  = addStringGadget(event, 750, 235, 5,, 3)
oppCreatP  = addStringGadget(event, 820, 235, 5,, 3)
ownWall    = addStringGadget(event, 750, 250, 5,, 3)
oppWall    = addStringGadget(event, 820, 250, 5,, 3)
ownTower   = addStringGadget(event, 750, 265, 5,, 3)
oppTower   = addStringGadget(event, 820, 265, 5,, 3)
TO_SetText ownStone,  str(player(1).stone)
TO_SetText oppStone,  str(player(2).stone)
TO_SetText ownCryst,  str(player(1).crystal)
TO_SetText oppCryst,  str(player(2).crystal)
TO_SetText ownCreat,  str(player(1).creature)
TO_SetText oppCreat,  str(player(2).creature)
TO_SetText ownStoneP, str(player(1).pStone)
TO_SetText oppStoneP, str(player(2).pStone)
TO_SetText ownCrystP, str(player(1).pCrystal)
TO_SetText oppCrystP, str(player(2).pCrystal)
TO_SetText ownCreatP, str(player(1).pCreature)
TO_SetText oppCreatP, str(player(2).pCreature)
TO_SetText ownWall,   str(player(1).wall)
TO_SetText oppWall,   str(player(2).wall)
TO_SetText ownTower,  str(player(1).tower)
TO_SetText oppTower,  str(player(2).tower)
gadgetOn descName
gadgetOn descCost
gadgetOn descComm
gadgetOn descOwn
gadgetOn descOpp
gadgetOn descStone
gadgetOn descCryst
gadgetOn descCreat
gadgetOn descStoneP
gadgetOn descCrystP
gadgetOn descCreatP
gadgetOn descWall
gadgetOn descTower
gadgetOn ownStone
gadgetOn oppStone
gadgetOn ownCryst
gadgetOn oppCryst
gadgetOn ownCreat
gadgetOn oppCreat
gadgetOn ownStoneP
gadgetOn oppStoneP
gadgetOn ownCrystP
gadgetOn oppCrystP
gadgetOn ownCreatP
gadgetOn oppCreatP
gadgetOn ownWall
gadgetOn oppWall
gadgetOn ownTower
gadgetOn oppTower

cardname   = addStringGadget(event, 110, 300, 25,, 24)
costValue  = addStringGadget(event, 450, 300, 4,, 2, 1)
costType   = addComboBox(event, 500, 300, 10, 3)
descCommon = addStringGadget(event, 10, 340, 97)
againLabel = addLabel(event, 650, 302, "danach")
againCombo = addComboBox(event, 710, 300, 18, 5)
TO_AppendLine againCombo, "-- weiter --"
TO_AppendLine againCombo, "nochmal (normal)"
TO_AppendLine againCombo, "nochmal Stein"
TO_AppendLine againCombo, "nochmal Kristall"
TO_AppendLine againCombo, "nochmal Kreatur"
gadgetOn againLabel
gadgetOn againCombo
TO_AppendLine costType, "Steine"
TO_AppendLine costType, "Kristalle"
TO_AppendLine costType, "Kreaturen"
TO_SetCursor costType, 1, 1
gadgetOn cardName
gadgetOn costValue
gadgetOn costType
gadgetOn descCommon
for i as integer   = 0 to 3
  cond1Combo(i)    = addComboBox(event,  50, 370 + i*75, 19, ubound(condList)+1)
  cond2Combo(i)    = addComboBox(event, 330, 370 + i*75, 19, ubound(condList)+1)
  TO_AppendLine cond1Combo(i), "<immer>"
  TO_AppendLine cond2Combo(i), "<Wert>"
  for k as integer = 1 to ubound(condList)
    TO_AppendLine cond1Combo(i), condList(k)
    TO_AppendLine cond2Combo(i), condList(k)
  next
  compCombo(i)     = addComboBox(event, 230, 370 + i*75, 9, 3)
  TO_AppendLine compCombo(i), "gleich"
  TO_AppendLine compCombo(i), "groesser"
  TO_AppendLine compCombo(i), "kleiner"
  compValue(i)     = addStringGadget(event, 505, 370 + i*75, 4, "", 3, 1)

  eff1Combo(i)     = addComboBox(event,  95, 390 + i*75, 22, ubound(effList)+1)
  eff2Combo(i)     = addComboBox(event,  95, 405 + i*75, 22, ubound(effList)+1)
  for k as integer = 0 to ubound(effList)
    TO_AppendLine eff1Combo(i), effList(k)
    TO_AppendLine eff2Combo(i), effList(k)
  next
  power1(i)        = addStringGadget(event, 295, 390 + i*75, 5, "", 4, 1)
  power2(i)        = addStringGadget(event, 295, 405 + i*75, 5, "", 4, 1)
  relat1Combo(i)   = addComboBox(event, 395, 390 + i*75, 19, ubound(condList)+1)
  relat2Combo(i)   = addComboBox(event, 395, 405 + i*75, 19, ubound(condList)+1)
  for k as integer = 0 to ubound(condList)
    TO_AppendLine relat1Combo(i), condList(k)
    TO_AppendLine relat2Combo(i), condList(k)
  next
  descLabel(i)     = addLabel(event, 580, 377 + i*75, "spezielle Beschreibung")
  desc1(i)         = addStringGadget(event, 575, 390 + i*75, 39)
  desc2(i)         = addStringGadget(event, 575, 405 + i*75, 39)
  relat1Label(i)   = addLabel(event, 350, 392 + i*75, "% von")
  relat2Label(i)   = addLabel(event, 350, 407 + i*75, "% von")
  ifLabel(i)       = addLabel(event,  10, 372 + i*75, "Wenn")
  thenLabel(i)     = addLabel(event,  55, 392 + i*75, "dann")
  elseLabel(i)     = addLabel(event,  55, 407 + i*75, "sonst")
  gadgetOn cond1Combo(i)
  gadgetOn ifLabel(i)
  compBox(i) = addListBox(event, 225, 370 + i*75, 8, 3)
next
readCards exepath & "/cards/" & set(setnumber), language
if ubound(card) < 14 then redim preserve card(14)
windowtitle set(setnumber)

dim as integer clickedCard = 0
dim shared as FB.Image ptr img(14)
for i as integer = 0 to 14
  if i > ubound(card) then
    img(i) = imagecreate(100, 140, 0)
    line img(i), (0, 0)-(99, 139), &hffffff, b
  else
    img(i) = cardImg(card(i), player(), 1)
  end if
  put ((i mod 9)*100, (i\9)*140), img(i), pset
next

setCard 0, condList(), effList()

do
  event->xSleep(1)
  if LMB then
    if MOUSEY < 280 then
      if (MOUSEY\140)*9 + MOUSEX\100 < 15 then
        clickedCard = (MOUSEY\140)*9 + MOUSEX\100
        setCard clickedCard, condList(), effList()
      end if
    end if
  end if
  if multikey(FB.SC_CONTROL) and (multikey(FB.SC_LEFT) or multikey(FB.SC_RIGHT)) then
    writeCards "cards/" & set(setnumber), language
    if multikey(FB.SC_LEFT) then
      setnumber -= 1
      if setnumber < 0 then setnumber = ubound(set)
    elseif multikey(FB.SC_RIGHT) then
      setnumber += 1
      if setnumber > ubound(set) then setnumber = 0
    end if
    erase card
    readCards "cards/" & set(setnumber), language
    if ubound(card) < 14 then redim preserve card(14)
    clickedCard = 0
    setCard 0, condList(), effList()
    windowtitle set(setnumber)
    updateAll player()
  end if
  with card(clickedCard)
    if event->GADGETMESSAGE then
      player(1).stone = valint(TO_GetLineContent(ownStone, 1))
      player(2).stone = valint(TO_GetLineContent(oppStone, 1))
      player(1).crystal = valint(TO_GetLineContent(ownCryst, 1))
      player(2).crystal = valint(TO_GetLineContent(oppCryst, 1))
      player(1).creature = valint(TO_GetLineContent(ownCreat, 1))
      player(2).creature = valint(TO_GetLineContent(oppCreat, 1))
      player(1).pStone = valint(TO_GetLineContent(ownStoneP, 1))
      player(2).pStone = valint(TO_GetLineContent(oppStoneP, 1))
      player(1).pCrystal = valint(TO_GetLineContent(ownCrystP, 1))
      player(2).pCrystal = valint(TO_GetLineContent(oppCrystP, 1))
      player(1).pCreature = valint(TO_GetLineContent(ownCreatP, 1))
      player(2).pCreature = valint(TO_GetLineContent(oppCreatP, 1))
      player(1).wall = valint(TO_GetLineContent(ownWall, 1))
      player(2).wall = valint(TO_GetLineContent(oppWall, 1))
      player(1).tower = valint(TO_GetLineContent(ownTower, 1))
      player(2).tower = valint(TO_GetLineContent(oppTower, 1))
      .cardname = TO_GetLineContent(cardName, 1)
      .costtype = getComboBoxVal(costType)
      .cost = valint(TO_GetLineContent(costValue, 1))
      if .cost > 99 then
        .cost = 99
        TO_SetLineContent costValue, 1, "99"
        updateGadget costValue
      end if
      select case getComboBoxVal(againCombo)
        case 1 : .special = 0
        case 2 : .special = 1
        case 3 : .special = 3
        case 4 : .special = 5
        case 5 : .special = 7
      end select
      .desc = TO_GetLineContent(descCommon, 1)
      for i as integer = 0 to 3
        .effect(i).cond1 = getComboBoxVal(cond1Combo(i)) - 1
        .effect(i).cond2 = getComboBoxVal(cond2Combo(i)) - 1
        .effect(i).compValue = valint(TO_GetLineContent(compValue(i), 1))
        .effect(i).relation = getComboBoxVal(relat1Combo(i)) - 1
        .effect(i).relatAlt = getComboBoxVal(relat2Combo(i)) - 1
        .effect(i).effectType = getComboBoxVal(eff1Combo(i)) - 1
        .effect(i).effectTypeAlt = getComboBoxVal(eff2Combo(i)) - 1
        .effect(i).power = valint(TO_GetLineContent(power1(i), 1))
        .effect(i).powerAlt = valint(TO_GetLineContent(power2(i), 1))
        .effect(i).desc = TO_GetLineContent(desc1(i), 1)
        .effect(i).descAlt = TO_GetLineContent(desc2(i), 1)
        .effect(i).comp = getComboBoxVal(compCombo(i))
      next
      updateCard clickedCard, player()
      setCard clickedCard, condList(), effList()
    end if
  end with
loop until event->EXITEVENT

for i as integer = 0 to 14
  imagedestroy img(i)
next

writeCards "cards/" & set(setnumber), language
delete event

sub gadgetOnSleep(onSleep as integer, gad as Gadget ptr)
  if onSleep then gadgetSleep gad else gadgetOn gad
end sub

function getCondName(condition as TCond) as string
  select case condition
    case TCond.ownStone         : return "ownStone"
    case TCond.ownCrystal       : return "ownCrystal"
    case TCond.ownCreature      : return "ownCreature"
    case TCond.ownStoneProd     : return "ownStoneProd"
    case TCond.ownCrystalProd   : return "ownCrystalProd"
    case TCond.ownCreatureProd  : return "ownCreatureProd"
    case TCond.ownWall          : return "ownWall"
    case TCond.ownTower         : return "ownTower"
    case TCond.oppStone         : return "opponentStone"
    case TCond.oppCrystal       : return "opponentCrystal"
    case TCond.oppCreature      : return "opponentCreature"
    case TCond.oppStoneProd     : return "opponentStoneProd"
    case TCond.oppCrystalProd   : return "opponentCrystalProd"
    case TCond.oppCreatureProd  : return "opponentCreatureProd"
    case TCond.oppWall          : return "opponentWall"
    case TCond.oppTower         : return "opponentTower"
    case TCond.diffStone        : return "differenceStone"
    case TCond.diffCrystal      : return "differenceCrystal"
    case TCond.diffCreature     : return "differenceCreature"
    case TCond.diffStoneProd    : return "differenceStoneProd"
    case TCond.diffCrystalProd  : return "differenceCrystalProd"
    case TCond.diffCreatureProd : return "differenceCreatureProd"
    case TCond.diffWall         : return "differenceWall"
    case TCond.diffTower        : return "differenceTower"
    case TCond.diffOwnBuilding  : return "differenceOwnBuilding"
    case TCond.diffOppBuilding  : return "differenceOpponentBuilding"
  end select
  return ""
end function

function getEffectName(condition as TCond, power as integer) as TEffPair
  select case condition
    case TEffectType.changeOwnStoneProd     : return type<TEffPair>("addProductionStone", "self")
    case TEffectType.changeOppStoneProd     : return type<TEffPair>("addProductionStone", "enemy")
    case TEffectType.changeBothStoneProd    : return type<TEffPair>("addProductionStone", "both")
    case TEffectType.changeOwnCrystalProd   : return type<TEffPair>("addProductionCrystal", "self")
    case TEffectType.changeOppCrystalProd   : return type<TEffPair>("addProductionCrystal", "enemy")
    case TEffectType.changeBothCrystalProd  : return type<TEffPair>("addProductionCrystal", "both")
    case TEffectType.changeOwnCreatureProd  : return type<TEffPair>("addProductionCreature", "self")
    case TEffectType.changeOppCreatureProd  : return type<TEffPair>("addProductionCreature", "enemy")
    case TEffectType.changeBothCreatureProd : return type<TEffPair>("addProductionCreature", "both")
    case TEffectType.changeOwnStone         : return type<TEffPair>("addStone", "self")
    case TEffectType.changeOppStone         : return type<TEffPair>("addStone", "enemy")
    case TEffectType.changeBothStone        : return type<TEffPair>("addStone", "both")
    case TEffectType.changeOwnCrystal       : return type<TEffPair>("addCrystal", "self")
    case TEffectType.changeOppCrystal       : return type<TEffPair>("addCrystal", "enemy")
    case TEffectType.changeBothCrystal      : return type<TEffPair>("addCrystal", "both")
    case TEffectType.changeOwnCreature      : return type<TEffPair>("addCreature", "self")
    case TEffectType.changeOppCreature      : return type<TEffPair>("addCreature", "enemy")
    case TEffectType.changeBothCreature     : return type<TEffPair>("addCreature", "both")
    case TEffectType.stealStoneProd         : return type<TEffPair>("stealProductionStone", "")
    case TEffectType.stealCrystalProd       : return type<TEffPair>("stealProductionCrystal", "")
    case TEffectType.stealCreatureProd      : return type<TEffPair>("stealProductionCreature", "")
    case TEffectType.stealStone             : return type<TEffPair>("stealStone", "")
    case TEffectType.stealCrystal           : return type<TEffPair>("stealCrystal", "")
    case TEffectType.stealCreature          : return type<TEffPair>("stealCreature", "")
    case TEffectType.changeOwnWall
      if power > 0 then return type<TEffPair>("buildWall", "self")   else return type<TEffPair>("damageWall", "self")
    case TEffectType.changeOppWall
      if power > 0 then return type<TEffPair>("buildWall", "enemy")  else return type<TEffPair>("damageWall", "enemy")
    case TEffectType.changeBothWall
      if power > 0 then return type<TEffPair>("buildWall", "both")   else return type<TEffPair>("damageWall", "both")
    case TEffectType.changeOwnTower
      if power > 0 then return type<TEffPair>("buildTower", "self")  else return type<TEffPair>("damageTower", "self")
    case TEffectType.changeOppTower
      if power > 0 then return type<TEffPair>("buildTower", "enemy") else return type<TEffPair>("damageTower", "enemy")
    case TEffectType.changeBothTower
      if power > 0 then return type<TEffPair>("buildTower", "both")  else return type<TEffPair>("damageTower", "both")
    case TEffectType.ownDamage   : return type<TEffPair>("damage", "self")
    case TEffectType.oppDamage   : return type<TEffPair>("damage", "enemy")
    case TEffectType.bothDamage  : return type<TEffPair>("damage", "both")
  end select
  return type<TEffPair>("", "")
end function

sub setCard(c as integer, condList() as string, effList() as string)
  screenlock
  dim as string compList(1 to 3) = { "gleich", "groesser", "kleiner" }
  'gadgetOn cardName
  'gadgetOn costValue
  'gadgetOn costType
  'gadgetOn descCommon
  'gadgetOn againCombo
  for i as integer = 0 to 3
    gadgetOn cond1Combo(i)
    gadgetOn eff1Combo(i)
    gadgetOn relat1Combo(i)
    gadgetOn ifLabel(i)
    gadgetOff thenLabel(i)
    gadgetOff elseLabel(i)
    gadgetOff relat2Label(i)
  next
  with card(c)
    TO_SetText cardName, .cardname
    TO_CursorKeyEnd cardname
    TO_SetText costValue, str(.cost)
    TO_CursorKeyEnd costValue
    TO_SetText descCommon, .desc
    TO_CursorKeyEnd descCommon
    setComboBoxVal costType, .costtype
    select case .special
      case 1    : setComboBoxVal againCombo, 2
      case 3    : setComboBoxVal againCombo, 3
      case 5    : setComboBoxVal againCombo, 4
      case 7    : setComboBoxVal againCombo, 5
      case else : setComboBoxVal againCombo, 1
    end select
    updateGadget cardName
    updateGadget costValue
    updateGadget descCommon
    for i as integer = 0 to 3
      with .effect(i)
        setComboboxVal cond1Combo(i), .cond1 + 1
        setComboboxVal cond2Combo(i), .cond2 + 1
        setComboboxVal compCombo(i), .comp
        if .cond1 = TCond.none then
          gadgetOff compCombo(i)
          gadgetOff cond2Combo(i)
          gadgetOff compValue(i)
          gadgetOff eff2Combo(i)
          gadgetOff power2(i)
          gadgetOff relat2Combo(i)
          gadgetOff desc2(i)
        else
          gadgetOn compCombo(i)
          gadgetOn cond2Combo(i)
          gadgetOn eff2Combo(i)
          gadgetOn power2(i)
          gadgetOn relat2Combo(i)
          gadgetOn desc2(i)
          gadgetOn thenLabel(i)
          gadgetOn elseLabel(i)
          if .cond2 = TCond.none then
            gadgetOn compValue(i)
            TO_SetText compValue(i), str(.compvalue)
            TO_CursorKeyEnd compValue(i)
            updateGadget compValue(i)
          else
            gadgetOff compValue(i)
          end if
        end if
        setComboBoxVal(eff1Combo(i), .effectType + 1)
        setComboBoxVal(relat1Combo(i), .relation + 1)
        setComboBoxVal(eff2Combo(i), .effectTypeAlt + 1)
        setComboBoxVal(relat2Combo(i), .relatAlt + 1)
        if .effectType = TEffectType.none then
          gadgetOff power1(i)
          gadgetOff relat1Combo(i)
          gadgetOff descLabel(i)
          gadgetOff desc1(i)
          gadgetOff eff2Combo(i)
          gadgetOff power2(i)
          gadgetOff relat2Combo(i)
          gadgetOff desc2(i)
          gadgetOff relat1Label(i)
        else
          TO_SetText power1(i), str(.power)
          updateGadget power1(i)
          TO_SetText desc1(i), .desc
          updateGadget desc1(i)
          gadgetOn power1(i)
          gadgetOn descLabel(i)
          gadgetOn desc1(i)
          if .relation = TCond.none then gadgetOff relat1Label(i) else gadgetOn relat1Label(i)
          if .effectTypeAlt = TEffectType.none then
            gadgetOff power2(i)
            gadgetOff relat2Combo(i)
            gadgetOff desc2(i)
          elseif .cond1 <> TCond.none then
            TO_SetText power2(i), str(.powerAlt)
            updateGadget power2(i)
            TO_SetText desc2(i), .descAlt
            updateGadget desc2(i)
            if .relatAlt <> TCond.none then gadgetOn relat2Label(i)
          end if
        end if
      end with
      updateGadget cond1Combo(i)
      updateGadget cond2Combo(i)
      updateGadget relat1Combo(i)
      updateGadget relat2Combo(i)
    next
  end with
  screenunlock
end sub

sub updateAll(player() as TPlayer)
  for i as integer = 0 to 14
    updateCard i, player()
  next
end sub

sub updateCard(c as integer, player() as TPlayer)
  imagedestroy img(c)
  img(c) = cardImg(card(c), player(), 1)
  put ((c mod 9)*100, (c\9)*140), img(c), pset
end sub

sub writeCards(filename as string, language as string)
  dim tempstring as string, ind as string, p as integer, file as integer = freefile, pair as TEffPair
  open filename for output as #file
  print #file, "<?xml version=""1.0"" encoding=""utf-8"" ?>"
  print #file, "<cards version=""1.0"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" ";
  print #file, "xsi:noNamespaceSchemaLocation=""cards.xsd"">"
  for i as integer = 0 to ubound(card)
    with card(i)
      print #file, "  <card>"
      print #file, "    <name lang=""" & language & """>" & .cardname & "</name>"
      select case .costtype
        case TCond.ownStone    : print #file, "    <costStone>"    & .cost & "</costStone>"
        case TCond.ownCrystal  : print #file, "    <costCrystal>"  & .cost & "</costCrystal>"
        case TCond.ownCreature : print #file, "    <costCreature>" & .cost & "</costCreature>"
      end select
      if len(.desc) then print #file, "    <description lang=""" & language & """>" & .desc & "</description>"
      for k as integer = 0 to MAXEFFECTS-1
        if .effect(k).effectType = TEffectType.none then continue for
        if .effect(k).cond1 <> TCond.none then
          print #file, "    <if condition=""" & getCondName(.effect(k).cond1) & """ ";
          tempstring = iif(.effect(k).cond2 = TCond.none, str(.effect(k).compValue), getCondName(.effect(k).cond2))
          print #file, "compareWith=""" & tempstring & """ relation=""";
          select case .effect(k).comp
            case TComp.greater : print #file, "greater"">"
            case TComp.lower   : print #file, "lower"">"
            case else          : print #file, "equal"">"
          end select
          ind = "      "
        else
          ind = "    "
        end if
        p = .effect(k).power
        pair = getEffectName(.effect(k).effectType, p)
        select case .effect(k).effectType
          case changeOwnWall, changeOwnTower, changeOppWall, changeOppTower, changeBothWall, changeBothTower : p = abs(p)
        end select
        print #file, ind & "<" & pair.effect;
        if len(pair.target) then print #file, " target=""" & pair.target & """";
        if .effect(k).relation <> TCond.none then print #file, " relation=""" & getCondName(.effect(k).relation) & """";
        print #file, ">" & p & "</" & pair.effect & ">"
        if len(.effect(k).desc) then
          print #file, ind & "<description lang=""" & language & """>" & .effect(k).desc & "</description>"
        end if
        if .effect(k).cond1 <> TCond.none andalso .effect(k).effectTypeAlt <> TEffectType.none then
          print #file, "    <else />"
          p = .effect(k).powerAlt
          pair = getEffectName(.effect(k).effectTypeAlt, p)
          select case .effect(k).effectTypeAlt
            case changeOwnWall, changeOwnTower, changeOppWall, changeOppTower, changeBothWall, changeBothTower : p = abs(p)
          end select
          print #file, ind & "<" & pair.effect;
          if len(pair.target) then print #file, " target=""" & pair.target & """";
          if .effect(k).relatAlt <> TCond.none then print #file, " relation=""" & getCondName(.effect(k).relatAlt) & """";
          print #file, ">" & p & "</" & pair.effect & ">"
          if len(.effect(k).descAlt) then
            print #file, ind & "<description lang=""" & language & """>" & .effect(k).descAlt & "</description>"
          end if
        end if
        if .effect(k).cond1 <> TCond.none then print #file, "    </if>"
      next
      select case .special and (Special.again or Special.stone or Special.creature)
        case Special.again                     : print #file, "    <again />"
        case Special.again or Special.stone    : print #file, "    <againStone />"
        case Special.again or Special.Crystal  : print #file, "    <againCrystal />"
        case Special.again or Special.Creature : print #file, "    <againCreature />"
      end select
      print #file, "  </card>"
    end with
  next
  print #file, "</cards>"
  close file
end sub
